#ifdef GL_ES
precision highp float;
#endif
attribute vec4 a_position;
attribute vec2 a_texCoord;
attribute vec4 a_color;

uniform vec2  u_contentSize;

uniform sampler2D u_normalMap;
uniform sampler2D u_normalMap2;
//浪花1
uniform sampler2D u_WaveFlowerMask1;
//浪花2 
uniform sampler2D u_WaveFlowerMask2;

//# 0=r,1=g,2=b,3=a
uniform int apass_index;
uniform vec3 u_ambient;

//暂停海水扰动,1:暂停
uniform int pause;


#ifdef GL_ES
varying highp vec4 v_fragmentColor;
varying highp vec2 v_texCoord;
highp mat4 rotationMatrix;
#else
varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
mat4 rotationMatrix;
#endif

varying vec3 centerpoint;
varying vec2 contentSize;

varying vec2 norCood;
varying vec2 norCood1;
varying vec3 ambient;
 

//平铺率
float flat_rate                 = 6.0;
float lastTime = 0.0;
 

void main()
{
    //gl_Position = CC_PMatrix * a_position;

    
    float time      = CC_Time.y;

    time  = pause   == 1 ?lastTime : time;

 	
 	  //轴旋转矩阵
 	  float angle   = 15.0 * 3.1415/180.0;
    rotationMatrix = mat4(1.0, 0.0,      0.0,      0.0,
                           0.0, cos(angle),   -sin(angle),  0.0,
                           0.0, sin(angle),   cos(angle),   0.0,
                           0.0, 0.0,      0.0,      1.0);
    
    
    vec4 apos     = rotationMatrix * a_position;
    gl_Position   = CC_PMatrix * apos; 


    v_fragmentColor = a_color;
    v_texCoord 		= a_texCoord;

  
    

    centerpoint     = vec3(u_contentSize.x/2.0,u_contentSize.y/2.0,0.0);
    contentSize 	= u_contentSize;


    //滚动纹理坐标
    norCood         = vec2(v_texCoord.x + time * -0.002,v_texCoord.y + time * -0.002);  
    norCood1        = vec2(v_texCoord.x + time * 0.004,v_texCoord.y + time * 0.004);     

    ambient         = u_ambient;
    lastTime        = time;
  }