#ifdef GL_ES
precision highp float;
#endif
//http://www.it165.net/pro/html/201411/26035.html
#ifdef GL_ES
varying highp vec4 v_fragmentColor;
varying highp vec2 v_texCoord;
#else
varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
#endif

uniform sampler2D u_normalMap;

float tile_factor = 0.2;
float noise_factor = 0.03;


void main() 
{
	
	vec2 position = v_texCoord.xy;//v_texCoord.xy / u_contentSize.xy;
	vec2 p = position * vec2(-1.0, -2.0);// vec2((position.x + 1.0)/2.0, position.y);

	p.x 	= 1.0 - p.x;
	
	if( p.y<-1.0)
	{
		// On Water Surface
		p.y=1.0-p.y;
		
		float t = fract(CC_Time.y/100.0);

	
		vec2 waterCoord = vec2(p.x, position.y);
		vec2 texCoordNormal0 = waterCoord * tile_factor;
		texCoordNormal0 += t ;
		
		vec2 texCoordNormal1 = waterCoord * tile_factor;
		texCoordNormal1.s -= t ;  
		texCoordNormal1.t += t ;
		
		vec3 normal0 = texture2D(u_normalMap, texCoordNormal0).rgb * 2.0 - 1.0;
		vec3 normal1 = texture2D(u_normalMap, texCoordNormal1).rgb * 2.0 - 1.0;
		vec3 normal = normalize(normal0 + normal1);
		
		//the final texture cooridnate is disturbed using the normal texture with some noise factor 
		p += noise_factor * normal.xy;		
	}

	gl_FragColor = texture2D(CC_Texture0, p); 
	
} 

void main_bak() 
{
	
	vec2 position = v_texCoord.xy;//v_texCoord.xy / u_contentSize.xy;
	vec2 p = position * vec2(-1.0, -2.0);// vec2((position.x + 1.0)/2.0, position.y);

	p.x 	= 1.0 - p.x;
	
	if( p.y<-1.0)
	{
		// On Water Surface
		p.y=1.0-p.y;
		
		float t = CC_Time.y/100.0;
	
		vec2 waterCoord = vec2(p.x, 1.0-position.y);
		vec2 texCoordNormal0 = waterCoord * tile_factor;
		texCoordNormal0 += t ;
		
		vec2 texCoordNormal1 = waterCoord * tile_factor;
		texCoordNormal1.s -= t ;  
		texCoordNormal1.t += t ;
		
		vec3 normal0 = texture2D(u_normalMap, texCoordNormal0).rgb * 2.0 - 1.0;
		vec3 normal1 = texture2D(u_normalMap, texCoordNormal1).rgb * 2.0 - 1.0;
		vec3 normal = normalize(normal0 + normal1);
		
		//the final texture cooridnate is disturbed using the normal texture with some noise factor 
		p += noise_factor * normal.xy;
		gl_FragColor = texture2D(CC_Texture0, p); 		
	}

	gl_FragColor = texture2D(CC_Texture0, p); 
	
} 