#ifdef GL_ES
precision mediump float;
#endif

uniform vec4  u_color;
uniform float u_alpha;

#ifdef GL_ES
 varying lowp vec4      v_fragmentColor; 
 varying mediump vec2   v_texCoord; 
#else
 varying vec4 v_fragmentColor;
 varying vec2 v_texCoord; 
#endif 

// 对ETC和置灰的支持
uniform int u_etc;
uniform float u_alpha_weight;
uniform sampler2D u_textureAlpha;
uniform int u_gray;

vec4 handleETC(vec4 color)
{
	color.a = texture2D(u_textureAlpha, v_texCoord).r;
    color.rgb *= color.a;
    // 下面这个会造成PKM黑边BUG
    //color.a = color.a * (1.0 + pow(0.001,color.a) * 5.0 );
    return color;
}

//置灰
vec4 handleGray(vec4 color)
{
	float gray = dot(color.rgb, vec3(0.2126, 0.7152, 0.0722));
	return vec4(gray, gray, gray, color.a);
}

void main()
{
	vec4 color = texture2D(CC_Texture0, v_texCoord);

  	color = u_etc == 1 ? handleETC(color) : color;
	color = u_gray == 1 ? handleGray(color) : color;

	color 	=  color* u_color * u_alpha;

	gl_FragColor = v_fragmentColor * color;
}


// void main(void) {
    
//     vec4 baseSrc            = texture2D( CC_Texture0, v_texCoord );  

//     gl_FragColor = baseSrc * u_color * u_alpha;    
// }
