#ifdef GL_ES
precision highp float;
#endif
//http://www.it165.net/pro/html/201411/26035.html
#ifdef GL_ES
varying highp vec4 v_fragmentColor;
varying highp vec2 v_texCoord;
#else
varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
#endif

uniform sampler2D u_normalMap;
uniform sampler2D u_normalMap2;
//浪花1
uniform sampler2D u_WaveFlowerMask1;
//浪花2
uniform sampler2D u_WaveFlowerMask2;

//灯光位置
uniform vec4  u_lightPosInLocalSpace;
uniform vec4  u_diffuseLightPosInLocalSpace;
// 
uniform vec4  u_eyePos;

//高光颜色
uniform vec3 u_specColor;

//uniform vec2  u_contentSize;
//灯光的漫反射颜色
uniform vec3  u_diffuseL;
//雾的颜色
uniform vec3  fog_color;
//雾的强度
uniform float fog_strength;
//浪花开关
uniform int    wave_flower_enabled;
 // 0 船坞，1战斗
uniform int sea_type;

///////////////////////////////////////
varying vec3 centerpoint;
varying vec2 contentSize;

varying vec2 norCood;
varying vec2 norCood1;

varying vec3 ambient;

uniform float u_renderLvl;

///////////////////////////////////////

//平铺率
float flat_rate_1               = 3.2;
//平铺率
float flat_rate_2                 = 7.3;
//浪尖颜色
vec4 wave_flower_color          = vec4(1.0);
//浪花1平铺系数
float wave_flower1_rate         = 2.0;
//浪花2平铺系数
float wave_flower2_rate         = 3.0;

//高光范围系数
float spec_range_rate_min       = 0.999999;
float spec_range_rate_max       = 1.0;
//环境光颜色
//vec3 ambient                    = vec3(0.0,0.0,0.0);


float blendOverlayf(float base,float blend) {
    return base < 0.5 ? (2.0 * base * blend) : (1.0 - 2.0 * (1.0 - base) * (1.0 - blend));
}

vec2 basecoord;
vec3 normcOlor;
vec4 baseColor;

void renderBase()
{
    vec2 normal1Coord               = fract(norCood * flat_rate_1);
    vec4 normal1                    = texture2D(u_normalMap, normal1Coord);
    //fract(norCood1 * flat_rate_2) 不能提到顶点着色器
    vec2 normal2Coord               = fract(norCood1 * flat_rate_2);
    vec4 normal2                    = texture2D(u_normalMap2, normal2Coord);

    normal1    = normal1 * 2.0 - 1.0;
    normal2    = normal2 * 2.0 - 1.0;
    
    //叠加
    float r         = normal1.x < 0.5 ? (2.0 * normal1.x * normal2.x) : (1.0 - 2.0 * (1.0 - normal1.x) * (1.0 - normal2.x));//blendOverlayf(normal1.r, normal2.r);
    float g         = normal1.y < 0.5 ? (2.0 * normal1.y * normal2.y) : (1.0 - 2.0 * (1.0 - normal1.y) * (1.0 - normal2.y));
    float b         = normal1.z < 0.5 ? (2.0 * normal1.z * normal2.z) : (1.0 - 2.0 * (1.0 - normal1.z) * (1.0 - normal2.z));
    
    normcOlor    = vec3(r,g,b);
    

    //normcOlor                       = normcOlor * 2.0 - 1.0;
    //基础纹理坐标
    basecoord    = v_texCoord + vec2(normcOlor.x,normcOlor.y);
    baseColor    = texture2D(CC_Texture0, basecoord); 

}

// 渲染高光
vec4 renderSpecLight()
{   

    vec3 eyedir                     = u_eyePos.xyz;
    vec4 lightPos                   = vec4(u_lightPosInLocalSpace.xyz,u_lightPosInLocalSpace.w);
    //当前像素的位置
    vec3 curPixelPosInLocalSpace    = vec3(basecoord.x*contentSize.x,basecoord.y*contentSize.y,0.0);

   
    vec3 norColor                   = normcOlor * 0.001;

    //灯光向量
    vec3 L                          = normalize(lightPos.xyz - curPixelPosInLocalSpace);
    //法线向量
    vec3 N                          = normalize(norColor);   
    vec3 E                          = normalize(eyedir - centerpoint);
    vec3 H                          = normalize(L + E); 
    //
    
    // 高光
    float spec_dot                  = dot(N,H);
    spec_dot                        = max(0.0,spec_dot);
    float specPer                   = pow(spec_dot,64.0);
    vec3 specular                   = u_specColor * smoothstep(spec_range_rate_min,spec_range_rate_max,specPer);


    return vec4(specular,1.0);

}

void main()
{
    renderBase();

    vec4 fragColor = baseColor;

    if (u_renderLvl > 2.0) {
        fragColor   = fragColor + renderSpecLight();
    }

    gl_FragColor    = fragColor;
    gl_FragColor = vec4(0.0);

}
