#ifdef GL_ES
precision mediump float;
#endif
attribute vec4 a_position; 
attribute vec2 a_texCoord; 
attribute vec4 a_color; 

uniform vec3 a_diffuse;
uniform vec3 a_ambient;
uniform vec3 afog_color;
//# 0=r,1=g,2=b,3=a
uniform float  apass_index;
uniform float afog_strength;
uniform vec3 u_nightLightColor;

 
varying vec3 diffuse;
varying vec3 ambient;
varying vec3 fog_color;
varying vec3 nightLightColor;
varying float pass_index;
varying float fog_strength; 


#ifdef GL_ES
 varying lowp vec4 v_fragmentColor; 
 varying mediump vec2 v_texCoord; 
#else
 varying vec4 v_fragmentColor;
 varying vec2 v_texCoord; 
#endif 


void main() { 
 	gl_Position 	= CC_PMatrix * a_position; 
 	v_fragmentColor = a_color; 
 	v_texCoord 		= a_texCoord; 

 	diffuse 		= a_diffuse;
    ambient 		= a_ambient;
    fog_color 		= afog_color;
    pass_index 		= apass_index;
    fog_strength 	= afog_strength;
    nightLightColor = u_nightLightColor;

    // 船坞海的高度
 	// float sea_height 	= 504.0;
 	// 舰船的高度
 	// float ship_height 	= 720.0;

 	// y_scale 			= 1.0;//sea_height / ship_height;
 	// y_offset 			= 0.0;//1.0 - y_scale;
 }