#ifdef GL_ES
precision mediump float;
#endif

uniform sampler2D u_waveTex;
uniform sampler2D u_waveTexMask;
uniform sampler2D  LightTex;

varying vec2 waveCood;



#ifdef GL_ES
 varying lowp vec4      v_fragmentColor; 
 varying mediump vec2   v_texCoord; 
#else
 varying vec4 v_fragmentColor;
 varying vec2 v_texCoord; 
#endif 

float edge0 = 0.02;
float edge1 = 0.94;
float smEdget=0.65;

// 浪花
vec4 getWaveFlower(float a) {
    vec2 wave1Coord   = fract(waveCood*4.0);
    vec4 wave2        = texture2D(u_waveTex, wave1Coord); 
    vec4 mask         = texture2D( u_waveTexMask, v_texCoord ); 

    a       = a > smEdget ? max(0.0,a - smoothstep(smEdget,edge1,a)) : a;
    wave2.a =    a * mask.r;
    
    return wave2;
}

void main(void) {    
    vec4 blendSrc   = texture2D( LightTex, v_texCoord ); 
    bool flag       = blendSrc.r <= edge1 && blendSrc.r >= edge0;

    gl_FragColor    = flag ? getWaveFlower(blendSrc.r):vec4(0.0,0.0,0.0,0.0);

}
