#ifdef GL_ES
precision mediump float;
#endif

// 舰船材质
uniform sampler2D   OverlayTex;

#ifdef GL_ES
 varying lowp vec4      v_fragmentColor; 
 varying mediump vec2   v_texCoord; 
#else
 varying vec4 v_fragmentColor;
 varying vec2 v_texCoord; 
#endif 

//叠加
float blendOverlayf(float base,float blend) {
    return base < 0.5 ? (2.0 * base * blend) : (1.0 - 2.0 * (1.0 - base) * (1.0 - blend));
}

vec4 overlay(vec4 base,vec4 blend) {
    float r         = blendOverlayf(base.r, blend.r);
    float g         = blendOverlayf(base.g, blend.g);
    float b         = blendOverlayf(base.b, blend.b);

    vec4 rst        = vec4(r, g, b,1.0); 

    return vec4(r, g, b,1.0);
}


void main(void) {
    
    vec4 baseSrc            = texture2D( CC_Texture0, v_texCoord );  

    vec2 coord = vec2(v_texCoord.x,v_texCoord.y);
    
    //混合图
    vec4 blendSrc           = texture2D( OverlayTex, coord );

    gl_FragColor    =  overlay(blendSrc,baseSrc);
    
    
}
